DECLARE @@RangeStart as DATETIME
SET @@RangeStart = CAST('2007-03-31' AS DATETIME)

DECLARE @@RangeEnd as DATETIME
SET @@RangeEnd = CAST('2007-04-05' AS DATETIME)

-- Will list all appointments (recurring or not) in the given range

SELECT	a.ID,
		a.Subject,
		ISNULL(o.StartDate, a.Start) as Start,
		ISNULL(o.EndDate, a.[End]) as [End]
FROM	Appointments a
		OUTER APPLY dbo.ExpandRecurrence(a.RecurrenceRule, @@RangeStart, @@RangeEnd) AS o
WHERE	-- Include non-recurring appointments in the range
		(a.RecurrenceRule IS NULL AND a.Start < @@RangeEnd AND a.[End] > @@RangeStart) OR
		-- And recurring appointments in range.
		(a.RecurrenceRule IS NOT NULL AND o.StartDate < @@RangeEnd AND o.EndDate > @@RangeStart)
ORDER BY Start