﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data.SqlTypes;
using Microsoft.SqlServer.Server;
using Telerik.Web.UI;


public class UserDefinedFunctions
{
	[SqlFunction(FillRowMethodName = "FillRow",
		TableDefinition = "StartDate DATETIME, EndDate DATETIME")]
	public static IEnumerable ExpandRecurrence(string recurrenceRule, SqlDateTime rangeStart, SqlDateTime rangeEnd)
	{
		List<OccurrenceInfo> occurrences = new List<OccurrenceInfo>();
		RecurrenceRule rrule;
		if (RecurrenceRule.TryParse(recurrenceRule, out rrule))
		{
			rrule.SetEffectiveRange(rangeStart.Value, rangeEnd.Value);
			foreach (DateTime occStart in rrule.Occurrences)
			{
				OccurrenceInfo info = new OccurrenceInfo(occStart, occStart.Add(rrule.Range.EventDuration));
				occurrences.Add(info);
			}
		}

		return occurrences;
	}

	public static void FillRow(Object obj, out SqlDateTime startDate, out SqlDateTime endDate)
	{
		OccurrenceInfo info = (OccurrenceInfo) obj;
		startDate = new SqlDateTime(info.Start);
		endDate = new SqlDateTime(info.End);
	}
}